/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.experlog.db;

import java.util.Hashtable;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.experlog.openeas.api.DataObject;

public class ESDBDataTuple implements DataObject {

    ResultSet rset_ = null;

    // Cache ResultSet columns... due to ODBC bugs (!)
    boolean cacheRS_ = false;
    Hashtable cache_ = null;

    public ESDBDataTuple(ResultSet rs, boolean cacheRS) throws SQLException {
        rset_ = rs;
        cacheRS_ = cacheRS;
        if (cacheRS) cache_ = new Hashtable();
    }

    public String get(String name) throws SQLException {

        String val = null;

        if (cacheRS_) {
            val = (String) cache_.get(name.toUpperCase()); // cache lookup
            if (val == null) {
                val = rset_.getString(name);
                if (val != null) cache_.put(name.toUpperCase(), val); // add to cache for next call
            }
        } else {
          try { 
            val = rset_.getString(name); 
          } catch (SQLException e) {
            try {
 	      val = rset_.getString(Integer.parseInt(name)); //maybe an index ?
 	    } catch(Exception e2) {
 	      throw e; //Throw the original exception
 	    }
          }	 
        }

        return val;
    }

}

