
package org.experlog.util;

// import java.util.Hashtable; JDK 1.4 -
import java.util.StringTokenizer;

public class StringUtils {

  public static String normalizeUrl(String in) {
    if(in == null) return "";
    String arg = in.trim();
    StringBuffer sbuff = new StringBuffer();

    char prevC = (char)-1;
    for(int i=0; i<arg.length(); i++) {
      char c = arg.charAt(i);

      if(Character.isWhitespace(c)) {
        if(! Character.isWhitespace(prevC)
         && sbuff.charAt(sbuff.length()-1) != '-') sbuff.append('-');
      }
      else switch(c) {

        case '': case '': case '': case '': case '': case '': case '':
          sbuff.append('a'); break;
        case '': case '': case '': case '': case '': case '': case '':
          sbuff.append('A'); break;
        case '': case '': case '': case '':
          sbuff.append('e'); break;
        case '': case '': case '': case '':
          sbuff.append('E'); break;
        case '': case '': case '': case '':
          sbuff.append('i'); break;
        case '': case '': case '': case '':// JDK 1.5 +
          sbuff.append('I'); break;
        case '': case '': case '': case '': case '': case '': case '':
          sbuff.append('o'); break;
        case '': case '': case '': case '': case '': case '':
          sbuff.append('O'); break;
        case '': case '': case '': case '':
        case '':
          sbuff.append('u'); break;
        case '': case '': case '': case '':
          sbuff.append('U'); break;
        case '': case '':
          sbuff.append('y'); break;
        case '':
        case '':
          sbuff.append('Y'); break;

        case '':
          sbuff.append('c'); break;
        case '':
          sbuff.append('C'); break;
        case '':
          sbuff.append('D'); break;
        case '':
          sbuff.append('n'); break;
        case '':
          sbuff.append('N'); break;
        case '':
          sbuff.append('s'); break;
        case '_':
          sbuff.append('-'); break;

        default:
          if(Character.isLetterOrDigit(c)) sbuff.append(c);
      }

      prevC = c;
    }

    return sbuff.toString();
  }

  public static String quoteMessage(String in) {
    return encodeWithRules("> " + in, "\n=\n> ;", ";");
  }

  public static String removeHtmlTags(String in) {
    if (in.indexOf('<') < 0)
      return in;
    if (in.indexOf('>') < 0)
      return in;
    String s = in;
    boolean startsWithLt = (in.startsWith("<"));
    StringTokenizer st = new StringTokenizer(s, "<");
    StringBuffer b;
    if (startsWithLt)
      b = new StringBuffer();
    else
      b = new StringBuffer(st.nextToken()); //at least 1 token
    while (st.hasMoreTokens()) { //now each token followed a "<"
      String tk = st.nextToken();
      int pos = tk.indexOf('>');
      if (pos < 0)
        b.append(" " + tk);
      else
        b.append(" " + tk.substring(pos + 1));
    }
    return b.toString();
  } // method removeHtmlTags

  public static String encodeWithRules(String s, String rules, String sep) {
    if (rules == null || s == null)
      return s;
    if (sep == null)
      sep = ";";
    StringTokenizer st = new StringTokenizer(rules, sep);
    // When using JDK 1.4 -, only 1 character could be replaced by a string using this method
    // With JDK 1.5, a string can be replaced by another string.
    // Uncomment 1.4 lines, and comment 1.5 lines, to get back to the old version if needed...
    //Hashtable subst = new Hashtable(); JDK 1.4 -
    String ret = new String(s); // JDK 1.5 +
    while (st.hasMoreTokens()) {
      String tok = st.nextToken();
      int pos = tok.lastIndexOf('=');
      if(pos <= 0) continue;
      
      String k = tok.substring(0, pos).replace("\\n", "\n").replace("\\r", "\r");
      String v = (pos >= tok.length()-1 ? "" : tok.substring(pos+1));
      
      /*
      StringTokenizer st2 = new StringTokenizer(st.nextToken(), "=");
      if (!st2.hasMoreTokens())
        continue;
      String k = st2.nextToken().replace("\\n", "\n").replace("\\r", "\r");
      if (!st2.hasMoreTokens())
        continue;
      String v = st2.nextToken();
      */
      if (v.equals("\" \""))
        v = " ";
      else if (v.equals("\"\""))
        v = "";

      //subst.put(k, v); JDK 1.4 -
      ret = ret.replace(k, v); // JDK 1.5 +
    }
    return ret; // JDK 1.5 +
    /* JDK 1.4 -
    StringBuffer buf = new StringBuffer();
    for (int i = 0; i < s.length(); i++) {
      char c = s.charAt(i);
      String sub = (String) subst.get(String.valueOf(c));
      if (sub == null)
        buf.append(c);
      else
        buf.append(sub.toString());
    }
    return buf.toString();
    */
  } // method encodeWithRules

  public static void main(String args[]) {
    System.out.println(StringUtils.normalizeUrl(args[0]));
  }

}

